# q

A programming language that compiles down to machine code.

## Features

- Fast compilation
- High performance
- Small executables
- Zero dependencies

## Installation

```shell
git clone https://git.akyoto.dev/cli/q
cd q
go build
```

This will place the compiler inside the repository.
Either use `./q` or get access to the shorter `q` in any directory with `ln -s $PWD/q ~/.local/bin/q`.

## Examples

You can take a look at the [examples](examples).

```shell
q run examples/hello
```

## Usage

```
Usage:

    q [command] [options]

Commands:

    build [directory | file]       build an executable from a file or directory
        --arch [arch]                  cross-compile for another CPU architecture [x86|arm|riscv]
        --assembler, -a                show assembler instructions
        --dry, -d                      skip writing the executable to disk
        --os [os]                      cross-compile for another OS [linux|mac|windows]
        --statistics, -s               show statistics
        --verbose, -v                  show everything

    run [directory | file]         build and run the executable
    system                         show system information
    help                           show this help
```

## Platforms

You can cross-compile executables for Linux, Mac and Windows.

```shell
q build examples/hello --os linux
q build examples/hello --os mac
q build examples/hello --os windows
```

## Status

`q` is under heavy development and not ready for production yet.
Feel free to [get in touch](https://akyoto.dev/contact) if you are interested in helping out.

The biggest obstacle right now is the lack of funding. If you want to help out financially you can [donate towards the project](https://en.liberapay.com/akyoto).

## License

Please see the [license documentation](https://akyoto.dev/license).

## Copyright

© 2023 Eduard Urbach
